-- Game version 8.2.0
local event= CreateFrame("frame")
event:RegisterEvent("ADDON_LOADED")
local spot=0
local Cost, Bt_TrainAll
local done=false

local function pauseit()
	spot=0
	Bt_TrainAll()
end

function Bt_TrainAll()
	if done==true then
		spot=0
		return
	end
	local Numskills=GetNumTrainerServices()
	local found=false
	while found==false do
		spot=spot+1
		local _,status,_=GetTrainerServiceInfo(spot)
		if status=="available" then
			BuyTrainerService(spot)
			C_Timer.After(0.3,pauseit)
			found=true
		end
		if spot>=Numskills then
			done=true
			break
		end
	end
end



local function createit()
	local Button = CreateFrame("Button", "TrainAllButton",ClassTrainerFrame, "MagicButtonTemplate")
	Button:SetText("Train All")
	Button:SetPoint("BOTTOMRIGHT",-96,4)
	Button:SetScript("OnEnter", function()
		GameTooltip:SetOwner(Button,"ANCHOR_RIGHT")
		GameTooltip:SetText("Train All available skills\nHold Shift to train all skills Instantly\nTotal cost is "..GetMoneyString(Cost))
	end)
	Button:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)
	Button:SetScript("ONClick",function() 
		if IsShiftKeyDown() then 
			BuyTrainerService(0) 
		else
			spot=0 
			done=false 
			Bt_TrainAll()
		end 
	end)
	if IsAddOnLoaded("ElvUI") then
		local E, L, V, P, G = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
		local S = E:GetModule('Skins')
		S:HandleButton(Button,1)
	end
	hooksecurefunc("ClassTrainerFrame_Update",function()
		Cost=0
		local Enable=false
		for i=1, GetNumTrainerServices() do
			local _,status,_=GetTrainerServiceInfo(i)
			if status == "available" then
				Cost=Cost+GetTrainerServiceCost(i)
				TrainAllButton:Enable()
				Enable=true
			end
		end
		if Enable==false then
			TrainAllButton:Disable()
		end
	end)
end

local function eventHandler(_,_,name)
	if name=="TrainAll" then
		if IsAddOnLoaded("Blizzard_TrainerUI") then
			createit()
			event:UnregisterEvent("ADDON_LOADED")
		end
	elseif name=="Blizzard_TrainerUI" then
		createit()
		event:UnregisterEvent("ADDON_LOADED")
	end
end

event:SetScript("OnEvent", eventHandler)
